//+------------------------------------------------------------------+
//|                                   Robby DSS Bressert Colored.mq4 |
//|                                                   Jaanus Jantson |
//|                          http://fx.jantson.ee; jaanus@jantson.ee |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_minimum -5
#property indicator_maximum 105
#property indicator_buffers 3
#property indicator_color1 DimGray  
#property indicator_width1 3
#property indicator_color2 Aqua                 
#property indicator_width2 2
#property indicator_color3 Red
#property indicator_width3 2
#property indicator_level1 95
#property indicator_level2 85
#property indicator_level3 15
#property indicator_level4 5


extern int       EMA_period=8;
extern int       Stochastic_period=5;


double DssBuffer[];
double MitBuffer[];
double DssBuffer_UP[];
double DssBuffer_DW[];


double smooth_coefficient;


int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,DssBuffer);
   SetIndexBuffer(1,DssBuffer_UP); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);
   SetIndexBuffer(2,DssBuffer_DW); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
   SetIndexBuffer(3,MitBuffer);
   
   SetIndexLabel(0, "DSS");
   SetIndexLabel(1, "DSS Up");
   SetIndexLabel(2, "DSS Down");

   IndicatorShortName ("DSS_Mod("+EMA_period+","+Stochastic_period+")");

   smooth_coefficient = 2.0 / (1.0 + EMA_period);
   return(0);
}


int start()
{
   int i, limit, counted_bars=IndicatorCounted(), Bar_OK;
   
   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=MathMin(Bars-counted_bars,Bars-1);

   for (i = limit; i >= 0; i--)
   {
      double HighRange = High[iHighest(NULL,0,MODE_HIGH,Stochastic_period,i)];
      double LowRange = Low[iLowest(NULL,0,MODE_LOW,Stochastic_period,i)];
      double delta = Close[i] - LowRange;
      if (HighRange!=LowRange)
         double MIT = delta/(HighRange - LowRange)*100.0;
      else      MIT = 0;         
      MitBuffer[i] = smooth_coefficient * (MIT - MitBuffer[i+1]) + MitBuffer[i+1];

      //
      //
      //
      //
      //
      
      HighRange = MitBuffer[ArrayMaximum(MitBuffer,Stochastic_period,i)];
      LowRange  = MitBuffer[ArrayMinimum(MitBuffer,Stochastic_period,i)];
      delta     = MitBuffer[i] - LowRange;
      if (HighRange!=LowRange)
         double DSS = delta/(HighRange - LowRange)*100.0;
      else      DSS = 0;         
      DssBuffer[i]    = smooth_coefficient * (DSS - DssBuffer[i+1]) + DssBuffer[i+1];

      //
      //
      //
      //
      //
      
      DssBuffer_DW[i] = EMPTY_VALUE;
      DssBuffer_UP[i] = EMPTY_VALUE;
      
      if   (DssBuffer[i]<DssBuffer[i+1]) DssBuffer_DW[i] = DssBuffer[i];
      if   (DssBuffer[i]>DssBuffer[i+1]) DssBuffer_UP[i] = DssBuffer[i];
   }            
 
    return(0);
   }
//================================================================================================= 